<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

# include kernel
require_once("./kernel.php");

if (!is_admin())
{
	Header("Location: ".PATH);
}

# begin admin menu
$admin_menu[] = array(0, "Статистика", "index.php", "images/mini_stat.gif");
$admin_menu[] = array(0, "Сервер", "admin.php", "images/mini_server.gif","server");
$admin_menu[] = array(1, "Перезагрзка", "?action=reload", "images/mini_configuration.gif");

# load modules
$modules_dir = dir("./modules");
while($file_name=$modules_dir->read())
{
	if(substr($file_name, 0, 3) == "mod" && is_file("./modules/".$file_name))
	{
		require_once("./modules/".$file_name);
	}
}
$modules_dir->close();

# get mod and action varibles from GET query
$mod = (isset($_GET['mod']) && $_GET['mod'] <> "" && function_exists($_GET['mod']."_init")) ? $_GET['mod'] : "";
$action = (isset($_GET['action'])) ? $_GET['action'] : "";
$oid = (isset($_GET['oid'])) ? $_GET['oid'] : "";

if ($mod <> "")
{
	call_user_func($mod."_init", $action, $oid);
}
else
{
	switch($action)
	{
		case "reload":
			if(isset($_GET['save']) && $_GET['save'] == "yes")
			{
            	$netams->reload();
				head_html("Перезагрузка сервера NetAMS");
				print("<font class=title>Сервер перезагружен!</title><br><br>".back_btn());
				foot_html();
			}
			else
			{
				head_html("Перезагрузка сервера NetAMS");
				$info = $netams->getinfo();
				print("<font class=title>Перезагрузка сервера NetAMS</title><br><br>");
	            note("Сервер работает: ".$info['runtime']."<br><br>".del_btn("Перезагрузить сервер NetAMS","?action=reload&save=yes","Вы действительно хотите перезагрузить NetAMS сервер?"));
				foot_html();
			}
		end;
		default:
		$table = new Table;
		$info = $netams->getinfo();
		head_html("Информация о сервере");
		print "<font class=title>Информация о сервере NetAMS</font><br>";
		$table->td("Главная|".$info['general']);
		$table->td("Время работы NetAMS|".$info['runtime']);
		$table->td("Время работы системы|".$info['systemtime']);
		$table->td("Процесс|".$info['proc']);
		$table->td("Процессор|".$info['cpu']);
		$table->td("Память|".$info['mem']);
		$table->show();
		print "<BR><font class=title>Информация о Системе</font><br>";
		$table->td("Платформа|".php_uname());
		$table->td("Версия PHP|".phpversion());
		$table->td("Версия mysql сервера|".mysql_get_server_info());
		$table->td("Версия mysql клиента|".mysql_get_client_info());
		$table->td("Тип соединения|".mysql_get_host_info());
		$table->td("Версия протокола|".mysql_get_proto_info());
		$table->show();
		print "<BR><font class=title>Установленные модули</font><br>";
		$table->title("Имя модуля|Версия|Автор|Почта|Комментарий");
		for($i=0;$i<count($modules_list);$i++)
		{
			$table->td($modules_list[$i][0]."|".$modules_list[$i][2]."|".$modules_list[$i][3]."|".$modules_list[$i][4]."|".$modules_list[$i][1]);
		}
		$table->show();

		foot_html();
		break;
	}
}

?>