<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

if (eregi("kernel.php",$_SERVER['PHP_SELF'])) {
    Header("Location: /");
    die();
}

DEFINE("version","0.4");

$modules_list[] = array("kernel", "Ядро NetAms Front", version, "Egor N. Zuskin", "ice@it2k.ru", "", "");

$xml = (isset($_GET['xml']) && $_GET['xml'] == "yes") ? true : false;

if (!file_exists("./config.php")){
	die("Not found config.php");
}

require_once("./config.php");

$current_data_base = isset($_COOKIE['current_data_base']) ? intval($_COOKIE['current_data_base']) : 0;

if(isset($_GET['action']) && $_GET['action'] == "change_db" && is_adv_user(intval($_GET['db'])))
{
	setcookie("current_data_base", intval($_GET['db']), mktime(23,59,59,date("m"),date("d"),date("Y")+1));
	header("Location: " . basename($_SERVER['SCRIPT_FILENAME']));
}

if ($current_data_base > 0 && !is_adv_user($current_data_base) )
{
	setcookie("current_data_base", "0",   mktime(23,59,59,date("m"),date("d"),date("Y")+1));
	header("Location: " . basename($_SERVER['SCRIPT_FILENAME']));
}

# renew $cfg varible
$arr = array_keys($data_base[$current_data_base]);
for($i=0;$i<count($arr);$i++)	$cfg[$arr[$i]] = $data_base[$current_data_base][$arr[$i]];

require_once("./include/class-calendar.php");
require_once("./include/class-ctree.php");
require_once("./include/class-table.php");
require_once "./include/class-netams-client.php";
require_once("./include/db.php");

$units_array       = array("group", "net", "cluster", "host", "user");
$units_array_title = array("Группа", "Сеть", "Кластер", "Хост", "Пользователь");

$netams = new NetAms(cfg("netamsclient"), cfg("netamstimeout"), cfg("netamscommandtimeout"));
$netams->cfg['ctl']  = cfg('netamsctl');
$netams->cfg['host'] = cfg('netamshost');
$netams->cfg['port'] = cfg('netamsport');
$netams->cfg['user'] = cfg('netamsuser');
$netams->cfg['pass'] = cfg('netamspass');
$netams->connect();

if ($netams->errorno > 0)
{
	head_html("Ошибка при подключении к NetAms");
	print("<br><br><center><br><br><font size=3><b>Извините, но в данный момент существует проблема с подключением к NetAms серверу!<br><br>Просим Вас зайти немного позже.</font></center></b>");
	print "<BR><BR><center>" .$netams->geterror() . "</center>";
	foot_html();
}

function _POST($AName)
{
	return (isset($_POST[$AName])) ? $_POST[$AName] : "";
}

function _GET($AName)
{
	return (isset($_GET[$AName])) ? $_GET[$AName] : "";
}

function head_html($page_title = "")
{
	global $data_base, $current_data_base, $netams;

	# get script name
	$script = basename($_SERVER['SCRIPT_FILENAME'],".php");
	# set base path of page title
	$base_title = ($script == "admin") ? "NetAms Administrator :: " : "NetAms Front :: ";
	$oid = (isset($_GET['oid'])) ? $_GET['oid'] : "";
	$link = ($oid <> "" && is_adv_user()) ? "?oid=".$oid : "";
	//is_admin();
	# begin html echo
	echo "<HTML>\n";
	echo "<HEAD>\n";
	echo "<META http-equiv=\"Pragma\" content=\"no-cache\">\n";
	echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />\n";
//	echo "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1251\">\n";
	echo "<TITLE>" . $base_title . $page_title . "</TITLE>\n";
	echo "<LINK REL=\"StyleSheet\" HREF=\"include/style.css\" TYPE=\"text/css\">\n";
	echo "</HEAD>\n";
	echo "<script language=\"javascript\" src=\"include/functions.js\"></script>\n";
	# get batabase list
	$db_list = "<select class='top' onchange=\"location='?action=change_db&db='+this.options[this.selectedIndex].value\">";
	for($i=0;$i<count($data_base);$i++)
	{
		$selected = ($i == $current_data_base) ? " selected" : "";
		$db_list .= is_adv_user($i) ? "<option value='".$i."'".$selected.">".$data_base[$i]['name']."</option>" : "";
	}
	$db_list .= "</select>";

	# search by ip and db list echo if advanced user
	$search_by_ip = (is_adv_user()) ? "IP:&nbsp;&nbsp;<form action='index.php' method=GET><input class=top type=\"text\" name=\"ip\"></form>&nbsp;&nbsp;<br>Выбор сервера:&nbsp;&nbsp;".$db_list ."&nbsp;&nbsp;" : "";
?>
	<BODY TOPMARGIN=0 LEFTMARGIN=0 BOTTOMMARGIN=0 RIGHTMARGIN=0>
	<TABLE width=100% height=100% cellpadding="0" cellspacing="0">
		<TR><TD width=100% bgcolor=#5b7bb2 valign=center height=30><table cellpadding="0" cellspacing="0" width=100%><td width=100%>&nbsp;&nbsp;<font size=5 color=white><b>NetAms Front</b></font><br>&nbsp;&nbsp;<font color=#FFFFFF>NetAMS version: <?php print $netams->version . " (" . $netams->build . ")" ?>  </font></td><td align=right><img height=1 width=300 src='images/space.gif'><br><?php print $search_by_ip; ?></td></table></TD></TR>
		<TR><TD width=100% height=1 bgcolor=#666666></TD></TR>
		<TR></TR><TR><TD hight=100% width=100% vAlign=top><TABLE hight=100% width=100%><TR><TD width=300 align=center vAlign=top><img height=10 width=200 src='images/space.gif'>
		<?php
			if ($script == "admin")
			{
				print "<table width=100%><tr><td width=100%>"; admin_navigation(); print "</td></tr></table>";
			}
			else
			{
				if ($script <> "quota")
				{
					print note(show_calendar($link));
				}
				if (is_adv_user())
				{
					print "<br><table width=100%><tr><td width=100%>"; adv_user_navigation(); print "</td></tr></table>";
				}
			}
		?>
		</TD><TD vAlign=top hight=100% width=100%>
		<TABLE hight=100% width=100%><TR><TD hight=100% width=100%>
<?php
}

function foot_html(){
global $netams;
?>
		</TD></TR></TABLE>
		<BR><BR><BR><TD><img width=10 src='images/space.gif'></TD></TD></TR></TABLE></TD></TR><TR><TD width=100% height=1 bgcolor=#666666></TD></TR>
		<TR><TD width="100%" bgcolor="#5b7bb2" align="center" valign="center" height="30"><a target='_blanc' href="http://www.it2k.ru/projects/netams-front/"><font color=white><b>NetAms Front v<?php print version ?></b></a><br>webmaster: Zuskin Egor</font></TD></TR>
	</table>
	</BODY>
</HTML>
<?php
	$netams->disconnect();
	die();
}

function replace_space_separator($AName)
{
	global $cfg;
	return str_replace($cfg['space_separator']," ",$AName);
}

function data_size($size)
{
	global $cfg;
	$name_arr[0] = 'б';
	$name_arr[1] = 'кб';
	$name_arr[2] = 'мб';
	$name_arr[3] = 'гб';

	$i=0;
	while($size > 921.6)
	{
		$size = ($size / 1024);
		$i++;
	}
	return round($size, $cfg['round_traffic_to'])." ".$name_arr[$i];
}

function preob($par){
	if ($par < 10){$par = substr($par, -1);$par = "0".$par;}
	return $par;
}

function print_unit_by_parent($ATree, $ALink = "index.php?oid=", $AParent = "", $AIndex = 0)
{
	global $units_list, $units_array;

	$oid = (isset($_GET['oid'])) ? $_GET['oid'] : "";
	$date = (isset($_GET['date'])) ? "&date=".$_GET['date'] : "";
	$month = (isset($_GET['month'])) ? "&month=".$_GET['month'] : "";
	$year = (isset($_GET['year'])) ? "&year=".$_GET['year'] : "";

	$url = $date.$month.$year;

	for($i=0;$i<count($units_array);$i++)
	{
		$items = units_parent($units_array[$i],$AParent);
		if (count($items) > 0)
		{
			$arr = array_keys($items);
			for($n=0;$n<count($items);$n++)
			{
				$item = $items[$arr[$n]];
				$expand = ($item['oid'] == $oid) ? true : false;
				if ($units_array[$i] == "group")
				{
					$ATree->addnode($AIndex, replace_space_separator($item['name']),$ALink.$item['oid'].$url,"images/mini_".$units_array[$i].".gif",$item['name'], $expand);
					if (trim($item['param']) <> "") print_unit_by_parent($ATree, $ALink, trim($item['name']), ($AIndex + 1));
				}
				else
				{
					$ATree->addnode($AIndex, replace_space_separator($item['name']),$ALink.$item['oid'].$url,"images/mini_".$units_array[$i].".gif","",$expand);
				}
			}
		}
	}
}

function adv_user_navigation($admin = 0)
{
	global $units_list;
	$script = basename($_SERVER['SCRIPT_FILENAME'],".php");
	$oid = (isset($_GET['oid'])) ? $_GET['oid'] : "";
	$date = (isset($_GET['date'])) ? "&date=".$_GET['date'] : "";
	$month = (isset($_GET['month'])) ? "&month=".$_GET['month'] : "";
	$year = (isset($_GET['year'])) ? "&year=".$_GET['year'] : "";
	$act = ($admin == 1) ? "&action=edit" : "";

	$link = $act.$date.$month.$year;
	$tree = new CTree;

	if (is_admin() && file_exists("./admin.php")) $tree->addnode(0,"Администрирование","admin.php","images/mini_admin.gif");
	if (file_exists("./stat.php") && $script <> "stat") $tree->addnode(0,"Сводная статистика","stat.php","images/mini_stat.gif");
	if ($script == "urls" || $script == "stat") $tree->addnode(0,"Статистика","index.php","images/mini_stat.gif");

	print_unit_by_parent($tree, (($script == "urls") ? "urls.php?oid=" : "index.php?oid="));

	$tree->showtree();
}

function unit_by_ip($ip)
{
	global $units_list;
	for($i=0;$i<count($units_list);$i++)
	{
		if (isset($units_list[$i]['param']) && eregi($ip,$units_list[$i]['param']." "))
		{
			return $units_list[$i];
		}
	}
	return array();
}

function unit_id_by($param, $value)
{
	global $units_list;
	for($i=0;$i<count($units_list);$i++)
	{
		if (isset($units_list[$i][$param]) && $units_list[$i][$param] == $value)
		{
			return $i;
		}
	}
	return -1;
}

function policy_id_by($value, $name = "name")
{
	global $policy_list;
	for($i=0;$i<count($policy_list);$i++)
	{
		if ($policy_list[$i][$name] == $value)
		{
			return $i;
		}
	}
	return -1;
}

function units_by($param, $value)
{
	global $units_list;
	$result = array();
	if($units_list == "") return array();
	for($i=0;$i<count($units_list);$i++)
	{
		if (isset($units_list[$i][$param]) && (trim($units_list[$i][$param]) == trim($value)))
		{
			$result[$units_list[$i]['oid']] = $units_list[$i];
		}
	}
	return $result;
}

function units_parent($AType, $AParent)
{
	global $units_list;
	$result = array();
	if($units_list == "") return array();
	for($i=0;$i<count($units_list);$i++)
	{
		if ((trim($units_list[$i]['type']) == $AType || $AType == "") && (((trim($AParent) == "") && (trim($units_list[$i]['parent']) == "")) || (((trim($AParent) <> "")) && (stripos($units_list[$i]['parent'], $AParent) !== false))))
		{
			$result[$units_list[$i]['oid']] = $units_list[$i];
		}
	}
	return $result;
}

function is_adv_user($db = 0)
{
	global $data_base;
	if (!isset($data_base[$db]['adv_users'])) return false;
	return eregi(@$_SERVER["REMOTE_ADDR"]." ", $data_base[$db]['adv_users']." ");
}

function is_admin()
{
	global $cfg;
	if (!isset($cfg['admins_ip'])) return false;
	return eregi(@$_SERVER["REMOTE_ADDR"], $cfg['admins_ip']);
}

function admin_navigation()
{
	global $admin_menu, $units_list, $netams;
	$tree = new CTree;
	$mod = (isset($_GET['mod'])) ? $_GET['mod'] : "";
	for($i=0;$i<count($admin_menu);$i++)
	{
		$tree->addnode($admin_menu[$i][0],str_replace(" ","&nbsp;",$admin_menu[$i][1]),@$admin_menu[$i][2],@$admin_menu[$i][3], @$admin_menu[$i][4]);
		if ($mod == "units" && $admin_menu[$i][1] == "Юниты")
		{
			$units_list = $netams->units();
			print_unit_by_parent($tree, "admin.php?mod=units&oid=", "", 1);
		}
	}

	$tree->showtree();

	if ($mod <> "")
	{
		expand_tree_node($mod);
	}
	else
	{
		expand_tree_node("server");
	}
}

function get_element_by_attr($arr, $atr, $value)
{
	for($i=0;$i<count($arr);$i++)
	{
		if (isset($arr[$i][$atr]) && $arr[$i][$atr] == $value)
		{
			return $arr[$i];
		}
	}
	return array();
}

function btn($name, $linc){
	return "<input type=\"button\" value=\"".$name."\" onclick=\"document.location.href='".$linc."'\">";
}

function del_btn($ATitle, $ALink, $AMessage = "Вы действительно хотите удалить элемент?")
{
	return "<input type=\"button\" value=\"".$ATitle."\" onclick=\"if(confirm('".$AMessage."'))document.location.href='".$ALink."'\">";
}

function back_btn()
{
	return '<input type="button" value="Вернуться" onclick="javascript:history.back();">';
}

function read_config($config_name)
{
	global $network_traffic_name, $local_traffic_name, $units_list;

	$handle = fopen ($config_name, "r");
	while (!feof ($handle))
	{
    	$buffer = fgets($handle, 4096);
    	$tmp = explode(" ", $buffer);
		if($tmp[0] == "unit" && $tmp[2] == "oid")
		{
			for($n=0;$n<count($tmp);$n=$n+2)
			{
				if (trim($tmp[$n]) == "acct-policy") break;
				if (isset($tmp[$n+1]))
				{
					$units_list[trim($tmp[3])][trim($tmp[$n])] = trim($tmp[$n+1]);
				}
			}
		}
	}
	fclose ($handle);
}

function error_html($error_text, $error_tex = "")
{
	global $xml;
	head_html("Ошибка данных");
	print("<br><br><center><br><br><font size=3><b>".$error_text."</font></center></b>");
	if (is_adv_user())
		print "<BR><BR><center>" .$error_tex . "</center>";
	foot_html();
}

function cfg($name)
{
	global $cfg;
	return (isset($cfg[$name])) ? $cfg[$name] : "";
}

function note($content, $caption = "")
{
?>
<div class="notes">
<table cellspacing="0" cellpadding="0" border="0" class="notes" >
	<tr class="top">
		<td class="gen left"><div class="empty"></div></td>
		<td><div class="empty"></div></td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
	<tr>
		<td class="gen left"><div class="empty"></div></td>
		<td class="gen content">
		<?php
		if ($caption <> "")
		{
			print "<font class=title>".$caption."</font><br><br>";
		}
		print $content;
		?>
		</td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
	<tr class="gen bottom">
		<td class="gen left"><div class="empty"></div></td>
		<td><div class="empty"></div></td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
</table>
</div>
<?php
}

function head_note($ACaption = "")
{
?>
<div class="notes">
<table cellspacing="0" cellpadding="0" border="0" class="notes" >
	<tr class="top">
		<td class="gen left"><div class="empty"></div></td>
		<td><div class="empty"></div></td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
	<tr>
		<td class="gen left"><div class="empty"></div></td>
		<td class="gen content">
		<?php
		if ($ACaption <> "")
		{
			print "<font class=title>". $ACaption."</font><br><br>";
		}
}

function foot_note()
{
?>
		</td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
	<tr class="gen bottom">
		<td class="gen left"><div class="empty"></div></td>
		<td><div class="empty"></div></td>
		<td class="gen right"><div class="empty"></div></td>
	</tr>
</table>
</div>
<?php
}

?>