<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

if (eregi("class-calendar.php",$_SERVER['PHP_SELF'])) {
    Header("Location: ".PATH);
    die();
}

function show_calendar($page_linc = ""){
	$date   = isset($_GET['date']) ? $_GET['date'] : date('d.m.Y');
	$tempdt = explode(".", $date);
	$month  = isset($_GET['month']) ? intval($_GET['month']) : $tempdt[1];
	$year   = isset($_GET['year']) ? intval($_GET['year']) : $tempdt[2];

	$page_linc = ($page_linc <> "") ? $page_linc."&" : "?";

	$months = array('Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь');
	$days   = array('пн','вт','ср','чт','пт','сб','вс');

	$daysamount = date('t', mktime(0, 0, 0,$month))+1;
	$weeks      = floor($daysamount/7);
	$firstday   = date('w',mktime(0,0,0,$month,0,$year));

	$content = '<table width="50" CLASS="calendar"><tr>';

	$content .= ($month>1) ? '<td class="head" align=center><a href="'.$page_linc.'month='.($month-1).'&year='.$year.'"><img src="images/arr_left.gif"></a></td>' : '<td CLASS="cel_tab" align=center><a href="'.$page_linc.'month=12&year='.($year-1).'"><img src="images/arr_left.gif"></a></td>';
	$content .= '<td class="head" colspan=5 align=center><a href="'.$page_linc.'month='.($month).'&year='.$year.'"><font class=cel>'.$months[$month-1].'</font></a></td>';
	$content .= ($month<12) ? '<td class="head" align=center><a href="'.$page_linc.'month='.($month+1).'&year='.$year.'"><img src="images/arr_rigth.gif"></a></td>' : '<td CLASS="cel_tab" align=center><a href="'.$page_linc.'month=1&year='.($year+1).'"><img src="images/arr_rigth.gif"></a></td>';

	$content.='</td></tr><tr>';
	foreach($days as $v)$content.='<td CLASS="days">'.$v.'</td>';
	$content.='</tr><tr>';
	for($i=0;$i<$firstday;$i++)$content.='<td></td>';
	if($month<date('n')){
		for($q=1;$q<$daysamount;$q++){
        	$month = Preob($month);
        	$q = Preob($q);
        	if ($tempdt[1] == $month AND $tempdt[0] == $q AND $tempdt[2] == $year){
        		$content .='<td CLASS="selected_day"><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';}
        	else{
				$content.='<td><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';
			}
			if(!strstr(($i+$q)/7,'.'))$content.='</tr><tr>';
		}
	} elseif($month>date('n')){
		for($q=1;$q<$daysamount;$q++){
        	$month = Preob($month);
        	$q = Preob($q);
        	if ($tempdt[1] == $month AND $tempdt[0] == $q AND $tempdt[2] == $year){
        		$content .='<td CLASS="selected_day"><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';}
        	else{
				$content.='<td><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';
			}
			if(!strstr(($i+$q)/7,'.'))$content.='</tr><tr>';
		}
	} elseif($month==date('n')){
		for($q=1;$q<date('d');$q++){
        	$month = Preob($month);
        	$q = Preob($q);
        	if ($tempdt[1] == $month AND $tempdt[0] == $q AND $tempdt[2] == $year){
        		$content .='<td CLASS="selected_day"><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';}
        	else{
				$content.='<td><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';
			}
			if (!strstr(($i+$q)/7,'.')) $content.='</tr><tr>';
		}
		$month = Preob($month);
		$q = Preob($q);

		$content.='<td CLASS="current_day"><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';
    	$this_day = ''.$q.'.'.$month.'.'.$year.'';
		if(!strstr(($i+$q)/7,'.'))$content.='</tr><tr>';

		for($q=date('d')+1;$q<$daysamount;$q++){
        	$month = Preob($month);
        	$q = Preob($q);
        	if ($tempdt[1] == $month AND $tempdt[0] == $q AND $tempdt[2] == $year){
        		$content .='<td CLASS="selected_day"><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';}
        	else{
				$content.='<td><a href="'.$page_linc.'date='.$q.'.'.$month.'.'.$year.'">'.$q.'</a></td>';
			}

			if(!strstr(($i+$q)/7,'.'))$content.='</tr><tr>';
		}
	}
	$content .= '</tr><tr><td align=center><a href="'.$page_linc.'month='.($month).'&year='.($year-1).'"><img src="images/arr_left.gif"></a></td><td colspan=5 align=center class=cel_tab>'.$year.'</td><td CLASS="cel_tab" align=center><a href="'.$page_linc.'month='.($month).'&year='.($year+1).'"><img src="images/arr_rigth.gif"></a></td></tr></table>';
	return $content;
}

function date_input($form, $name, $date = "") {
	$value = ($date <> "") ? $date : date("d.m.Y");
	$tmp = explode(".", $value);
	$mon = intval($tmp[1])-1;
	$year = $tmp[2];
	return "<input value=\"".$value."\" type=text name=\"".$name."\" size=8>&nbsp;<a href=\"javascript:show_calendar('".$form.".".$name."','".$mon."','".$year."','DD.MM.YYYY');\"><img class=form src=\"images/calendar.gif\" border=0></a></span>";
}

?>